﻿--Bar creation module

local width, height = 350, 24

function SN:SNCreateBG(frame)
	if(IsAddOnLoaded("ElvUI")) then
		local bg = CreateFrame("Frame")
		bg:SetTemplate("Default")
		bg:SetParent(frame)
		bg:ClearAllPoints()
		bg:Point("TOPLEFT", frame, "TOPLEFT", -2, 2)
		bg:Point("BOTTOMRIGHT", frame, "BOTTOMRIGHT", 2, -2)
		bg:SetFrameStrata("LOW")
		bg:Show()
	end
end

function SN:CreateBar(group, cooldown, duration, caster, guid, spell)
	local v = SN.Media
	local class, classFileName, classID = UnitClass(caster)
	--Start the CD Timer
	local bar = SN.timers:NewBar(nil, width, height, v.media.minTex)
	bar:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

	bar:SetData("SN:arg1", group)
	bar:SetData("SN:arg2", cooldown)
	bar:SetData("SN:arg3", guid)
	bar:SetData("SN:arg4", caster)
	bar:SetData("SN:arg5", spell)
	bar:SetData("SN:arg6", classID)

	local colortmp = RAID_CLASS_COLORS[classFileName]
	color = { colortmp.r, colortmp.g, colortmp.b }

	bar:SetIcon(select(3, GetSpellInfo(cooldown['spellID'])))
	
	bar:SetColor(color)
	bar:SetDuration(duration)
	bar:SetLabelFont(v.media.font, 16, "OUTLINE")
	if group == SN.F.debuffs then
		bar:SetLabel(spell)
	else
		bar:SetLabel(caster.."         "..spell)
	end
	SN:SNCreateBG(bar)
	bar.TimeSinceLastUpdate = 0
	bar.RegisterCallback(self, "FancyBar_BarStop", "CleanUpBars")
	bar:SetScript("OnEvent", function(self, event, ...)
		if event == "COMBAT_LOG_EVENT_UNFILTERED" then
			local _, type, _, _, _, _, _, destGUID, destname, _, _ = ...
			if type == "UNIT_DIED" then
				if destGUID == self:GetData("SN:arg3") then
					self:Stop()
				end
			end
		end	
	end)
	group:Add(bar)
	bar:Start()
	
end

function SN:CleanUpBars(callback, bar)

end

function SN:AnnounceCD(cooldown, caster)

	if(SN.V.defaults.profile.CD.castannounce) then
		local name = select(1, GetSpellInfo(cooldown['spellID']))
		
		local dur = cooldown['CD'] / 60

		if GetNumGroupMembers() > 1 and IsInRaid() then
			SendChatMessage(caster.." Casts "..name.." "..dur.."Min".." CD", "RAID")
		elseif GetNumGroupMembers() > 1 and not IsInRaid() then
			SendChatMessage(caster.." Casts "..name.." "..dur.."Min".." CD", "PARTY")
		else
			SendChatMessage(caster.." Casts "..name.." "..dur.."Min".." CD", "SAY")
		end
	end

	--local bar = SN:CreateBar(group, cooldown, duration, caster, guid, spell)
	
end