-- Cooldown Module

local width, height = 350, 28

function SN:CoolDowns()
	
	SN.F.cooldowns = SN.timers:NewGroup(350, "CDGroup", cdowngrp)
	SN.F.cooldowns:SetSpacing(0, 7)
	SN.F.cooldowns:SetSorting("SN:arg6")
	if(IsAddOnLoaded("ElvUI")) then
		SN.F.cooldowns:SetStartPoint("bottomleft")
		SN.F.cooldowns:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 5, 0)
	else
		SN.F.cooldowns:SetStartPoint("topleft")
		SN.F.cooldowns:SetPoint("CENTER", UIParent, "CENTER", -300, 200)
	end
	SN.F.cooldowns:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	SN.F.cooldowns:SetScript("OnEvent", function(self, event, unit, ...)
		SN:UpdateCooldown(self, event, unit, ...)
	end)
end

function SN:UpdateCooldown(group, event, unit, ...)

	if event == "COMBAT_LOG_EVENT_UNFILTERED" then

		local type, _, sourceGUID, sourceName,_,_, destGUID, destName =  ...
		local spellId, spellName, spellSchool = select(11, ...)

		for i, cooldown in pairs(SN.cooldowns) do
			if type == cooldown['succ'] then
				if spellId == cooldown['spellID'] then
					if UnitInParty(sourceName) or UnitInRaid(sourceName) or sourceGUID == UnitGUID("player") then
						local cast = select(7, GetSpellInfo(spellId))
						cast = cast * 0.001
						if cast > 0 then
							args = { group, cooldown, cooldown['CD'], sourceName, sourceGUID, spellName }
							SN:ScheduleTimer("StartCastDelay", cast, args)
						else
							SN:CreateBar(group, cooldown, cooldown['CD'], sourceName, sourceGUID, spellName)
						end
						SN:AnnounceCD(cooldown, sourceName)
					end
				end
			end
		end
	end
end

function SN:StartCastDelay(args)
	SN:CreateBar(args[1], args[2], args[3], args[4], args[5], args[6])
end